Index: /trunk/tools/documentation/install.html
===================================================================
--- /trunk/tools/documentation/install.html	(revision 1707)
+++ /trunk/tools/documentation/install.html	(revision 1708)
@@ -62,34 +62,26 @@
      <LI>Now all the scripts are held in ${HOME}/PyNCplot. It might be desirable to set an environment variable to make life easier:
       <DIV CLASS="codetxt">$ export pyHOME=${HOME}/PyNCplot</DIV>
-      <LI>Finally one need to compile the Fortran modules using the same python to run the scripts. This is done using a standard `Makefile' and the tool <A CLASS="la" HREF="https://docs.scipy.org/doc/numpy-dev/f2py/" TARGET="_blank">f2py</A> to link Fortran compiled codes to python. There are different versions for different LMD/IPSL and French HPC machines. For a standard linux 64-bits machine (debain 7) there is one example as `Makefile.foudre'. Follow the instructions there in after linking the appropriated file:</LI>
-      <DIV CLASS="codetxt">
-      $ ln -s Makefile.[machine].[compiler] ./Makefile
-      </DIV>
-      <LI>In order to create a python 'library' from the fortran codes, one need to follow these steps (example for machine called `foudre')</LI>
-      <OL>
-        <LI>Preparing the fortran-python bridge of the `diagnostics' related module</LI>
+      <LI>Finally one need to compile the Fortran modules using the same python to run the scripts. This is done using a standard `Makefile' and the tool <A CLASS="la" HREF="https://docs.scipy.org/doc/numpy-dev/f2py/" TARGET="_blank">f2py</A> to link Fortran compiled codes to python. There are different versions for different LMD/IPSL and French HPC machines. For a standard linux 64-bits machine (debain 9 with gcc compilers) there is one example as `Makefile.rayo'. Take one and specify a series of different variables specifically for the given machine
           <DIV CLASS="codetxt">
-            $ f2py -m module_ForDiag -h module_ForDiag.pyf module_generic.F90 module_ForDiagnosticsVars.F90 module_ForDiagnostics.F90 >& run_f2py_ForDiag_wrapper.log
+            FC 		= gfortran							# Fortran compiler
+            F2PY    = /usr/bin/f2py						# Path to the f2py tool
+            NCLIBFOLD	= /usr/lib/x86_64-linux-gnu		# Path to netcdf libraries
+            NCINCFOLD	= /usr/include					# Path to netcdf includes
           </DIV>
-        <LI>Creation of the binary objects of the Fortran codes</LI>
+        <LI>Then one only needs to link the Makefile and compile</LI>
           <DIV CLASS="codetxt">
-            $ make
-          </DIV>
-        <LI>Creation of the fortran-python `diagnostics' related module</LI>
-          <DIV CLASS="codetxt">
-            $ f2py -m module_ForDiag -c --f90exec=/usr/bin/gfortran-4.7 module_ForDiag.pyf module_generic.F90 module_ForDiagnosticsVars.F90 module_ForDiagnostics.F90 >& run_f2py_ForDiag_compile.log
-          </DIV>
-        <LI>Preparing the fortran-python bridge of the `interpolation' related module</LI>
-          <DIV CLASS="codetxt">
-            $ f2py -m module_ForInt -h module_ForInt.pyf module_generic.F90 module_ForInterpolate.F90  >& run_f2py_ForInt_wrapper.log
-          </DIV>
-        <LI>Creation of the fortran-python `diagnostics' related module</LI>
-          <DIV CLASS="codetxt">
-            $ f2py -m module_ForInt -c --f90exec=/usr/bin/gfortran-4.7 module_ForInt.pyf module_generic.F90 module_ForInterpolate.F90  >& run_f2py_ForInt_compile.log
+          $ ln -s Makefile.[machine].[compiler] ./Makefile<BR>
+          $ make >& run_make.log
           </DIV>
         <LI>At the end one should have: </LI>
-          <PRE><CODE>
-          module_ForDiag.so
-          module_ForInt.so
+          <UL>
+            <LI><PRE><CODE>DistriCorrection</CODE></PRE>: Complete fortran program to correct data by moving values within quantiles of the distribution</LI>
+            <LI><PRE><CODE>interpolate</CODE></PRE>: Complete fortran program to interpolate data using nearest-neighbors and weighted distances</LI>
+            <LI><PRE><CODE>module_ForDef.so</CODE></PRE>: python-callable package of fortran's definitions of variables</LI>
+            <LI><PRE><CODE>module_ForDistriCorrect.so</CODE></PRE>: python-callable package of fortran's correction of the distribution by moving values within quantiles of the distribution</LI>
+            <LI><PRE><CODE>module_ForSci.so</CODE></PRE>: python-callable package of fortran's scientific/mathematical all purpose functions</LI>
+            <LI><PRE><CODE>module_ForDiag.so</CODE></PRE>: python-callable package of fortran's computation of meteorological diagnostics</LI>
+            <LI><PRE><CODE>module_ForInt.so</CODE></PRE>: python-callable package of fortran's interpolation subroutines</LI>
+            <LI><PRE><CODE>trajectories_overlap</CODE></PRE>: Complete fortran program to define enclosed regions on a given 2D field and compute their trajectories following a maximum-overlaping criteria</LI>
           </CODE></PRE>
         </OL>